#ifndef __PCMCIAD_H__
#define __PCMCIAD_H__

enum devtypes {
     UNKNOWN,
     MODEM,
     ETHERNET,

     MAX_DEVTYPE,
};

/*
 * data structures for configuration file information
 */
struct prod_map {
     enum devtypes devtype;
     char *manufacturer, *prod_name, *addl_info1, *addl_info2;
     struct prod_map *next;
};

#define MAX_CONFIGS 12		/* config table entries */
#define MAX_IOADDRS 2		/* i/o port ranges */
#define MAX_MEMS 4		/* memory ranges */
#define MAX_SOCKS 8		/* pcic sockets */
#define MAX_NAMELEN 16		/* version info string len */

struct pcmcia_cfentry {
     int idx, defp;
     int irqp, irq, irq_mask;
     int iop, ios, io_16, io_addrs[MAX_IOADDRS], io_lens[MAX_IOADDRS];
     int memp, mems, mem_caddrs[MAX_MEMS], mem_lens[MAX_MEMS];
     int mem_haddrs[MAX_MEMS];
};

struct dev_action {
     enum devtypes devtype;
     struct pcmcia_cfentry cfent;
     char *init, *reset;
     int busy;
     struct dev_action *next;
};

/*
 * state information for each PC card socket
 */
enum sockstate { EMPTY, FULL, };

#ifdef USER_DRV
#include <linux/fs.h>
extern int errno;
#define ioctl(fd,cmd,arg) ((errno=-pcmcia_ioctl(&fd,0,cmd,arg)) ? -1 : 0)
#endif

struct pcic_sock {
#ifdef USER_DRV
     struct inode fd;
#else
     int fd;
#endif
     int valid;
     char cardp;
     char manufacturer[MAX_NAMELEN], prod_name[MAX_NAMELEN];
     char addl_info1[MAX_NAMELEN], addl_info2[MAX_NAMELEN];
     u_long base_addr;
     int regmask[4];
     int config_midx;
     struct pcmcia_cfentry configs[MAX_CONFIGS];
     struct pcmcia_attr_mem attrmem;
     u_short *mem_pos;
     enum sockstate state;
     enum devtypes devtype;
};

/* DO NOT ADD ANYTHING AFTER THIS #endif */
#endif /* __PCMCIAD_H__ */
