#include <stdio.h>

#include <linux/pcmcia.h> /* for attrmem */
#include "cis_defs.h"
#include "pcmciad.h"

void pcic_print_cfent(struct pcmcia_cfentry *cfent);

   void pcic_print_sock(struct pcic_sock *sock)
{
     int i;
     
     printf("PCIC socket:\n");
     if (!sock->valid)
	  printf("\tnot present\n");
     if (!sock->cardp)
	  printf("\tno card present\n");
     printf("\tVersion: %s, %s, %s, %s\n", sock->manufacturer,
	    sock->prod_name, sock->addl_info1, sock->addl_info2);
     printf("\tRegister offset %#x, mask 0x%04x%04x%04x%04x\n",
	    sock->base_addr, sock->regmask[3], sock->regmask[2],
	    sock->regmask[1], sock->regmask[0]);
#ifdef DEBUG
     printf("\tMax cfent entry %d\n", sock->config_midx);
#endif

     i = 0;
     while (i < MAX_CONFIGS) {
	  pcic_print_cfent(&sock->configs[i]);
	  if (sock->config_midx == sock->configs[i].idx)
	       break;
	  i++;
     }
     if (sock->config_midx != sock->configs[i].idx)
	  printf("\tLast config entry not present!\n");
}

void pcic_print_cfent(struct pcmcia_cfentry *cfent)
{
     int i;
     printf("\tConfig entry %d%s:\n", cfent->idx, cfent->defp ?
	    " (default)" : "");
     if (cfent->irqp)
	  printf("\t\tIRQ %d, mask %#x\n", cfent->irq, cfent->irq_mask);
     if (cfent->iop)
	  for (i = 0; i < cfent->ios; i++)
	       printf("\t\tI/O #%d: %#x->%#x (%d)\n", i, cfent->io_addrs[i],
		      cfent->io_addrs[i] + cfent->io_lens[i],
		      cfent->io_lens[i]);
     if (cfent->memp)
	  for (i = 0; i < cfent->mems; i++)
	       printf("\t\tMem #%d: %#x->%#x (%d) at %#x\n", i,
		      cfent->mem_caddrs[i],
		      cfent->mem_caddrs[i] + cfent->mem_lens[i], 
		      cfent->mem_lens[i], cfent->mem_haddrs[i]);
}

